create or replace procedure move_hold_archiv(p_like in varchar2 default '%')
is
/*
   HOLD in ARCHIV
  
*/
   hold_name  dbms_sql.Varchar2_Table;
   hold_pass  dbms_sql.Varchar2_Table;
   hold_hash  dbms_sql.Varchar2_Table;
   l_cnt     number := 0;
   l_cnt_max number := 100000;
   l_move    number := 0;
   cr_insert number;
   l_sql     varchar2(255);
   ldir      varchar2(512);           --    
   lfile     utl_file.file_type;      --       

   cr_sel_rec archiv%rowtype;

   cursor cr_sel is
   select distinct NAME, PASS, HASH 
     from HOLD;
--    where 
--      name like 'SYS%' 
--      AND HASH like p_like and 
--          name is not null
--      and hash is not null
--      and pass is not null;
      
   PROCEDURE PUT_LINE(p_text in varchar2)
   as
   begin
      utl_file.put_line(lfile, p_text);
      dbms_output.put_line(p_text);
   exception when others then null;
   end;

begin

cr_insert := dbms_utility.get_parameter_value('user_dump_dest',cr_insert,ldir); 
lfile := utl_file.fopen(ldir, 'Move  '||p_like||' '||to_char(sysdate,'hh24-mi-ss dd-mm-yyyy')||'.log', 'w', 32000);
put_line('  '||to_char(sysdate,'hh24-mi-ss dd-mm-yyyy'));

cr_insert := dbms_sql.open_cursor;
l_sql := 'insert /*+ APPEND*/ into ARCHIV values(:pNAME, :pPASS, :pHASH)';
dbms_sql.parse(cr_insert, l_sql, dbms_sql.native);

open cr_sel;
loop
  fetch cr_sel into cr_sel_rec;
  l_cnt := l_cnt + 1;
  hold_name(l_cnt) := cr_sel_rec.name;
  hold_pass(l_cnt) := cr_sel_rec.pass;
  hold_hash(l_cnt) := cr_sel_rec.hash;
  if l_cnt = l_cnt_max then
     dbms_sql.bind_array(cr_insert, ':pname', hold_name);
     dbms_sql.bind_array(cr_insert, ':ppass', hold_pass);
     dbms_sql.bind_array(cr_insert, ':phash', hold_hash);
     begin
        l_move := l_move + dbms_sql.execute(cr_insert);
        commit;  
        l_cnt := 0;
     exception when others then null;
     end;
  end if;
exit when cr_sel%notfound;  
end loop;

for i in 1..l_cnt loop
     dbms_sql.bind_variable(cr_insert,':pname', hold_name(i));
     dbms_sql.bind_variable(cr_insert,':ppass', hold_pass(i));
     dbms_sql.bind_variable(cr_insert,':phash', hold_hash(i));
     begin
        l_move := l_move + dbms_sql.execute(cr_insert);
     exception when others then null;
     end;
end loop;
commit;
close cr_sel;

put_line('  '||to_char(sysdate,'hh24-mi-ss dd-mm-yyyy'));
put_line(' '||l_move||' ');
if dbms_sql.is_open(cr_insert) then dbms_sql.close_cursor(cr_insert); end if;
if cr_sel%isopen then close cr_sel; end if;
if utl_file.is_open(lfile) then utl_file.fclose(lfile); end if;
--execute immediate 'truncate table hold';
exception
  when others then
     put_line(' '||l_move||'  -  !!!');
     put_line(SQLERRM);
     begin
       if dbms_sql.is_open(cr_insert) then dbms_sql.close_cursor(cr_insert); end if;
       if cr_sel%isopen then close cr_sel; end if;
       if utl_file.is_open(lfile) then utl_file.fclose(lfile); end if;
     exception when others then put_line(SQLERRM);
     end;  
end;
/
